/*
 * Copyright (C) 2010-2011  Internet Systems Consortium, Inc. ("ISC")
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND ISC DISCLAIMS ALL WARRANTIES WITH
 * REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS.  IN NO EVENT SHALL ISC BE LIABLE FOR ANY SPECIAL, DIRECT,
 * INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

/* $Id: pcp.h 1207 2011-06-29 17:13:22Z pselkirk $ */

/* PCP */

#define PCP_VERSION			1
#define PCP_RESPONSE			128
#define PCP_OC_MAP4			1
#define PCP_OC_MAP4_RESPONSE		PCP_OC_MAP4 | PCP_RESPONSE
#define PCP_OC_MAP6			2
#define PCP_OC_MAP6_RESPONSE		PCP_OC_MAP6 | PCP_RESPONSE
#define PCP_OC_PEER4			3
#define PCP_OC_PEER4_RESPONSE		PCP_OC_PEER4 | PCP_RESPONSE
#define PCP_OC_PEER6			4
#define PCP_OC_PEER6_RESPONSE		PCP_OC_PEER6 | PCP_RESPONSE
#define PCP_AF_IPv4			1
#define PCP_AF_IPv6			2
#define PCP_RC_SUCCESS			0
#define PCP_RC_UNSUPP_VERSION		1
#define PCP_RC_MALFORMED_REQUEST	2
#define PCP_RC_UNSUPP_OPCODE		3
#define PCP_RC_UNSUPP_OPTION		4
#define PCP_RC_MALFORMED_OPTION		5
#define PCP_RC_PROCESSING_ERROR		6
#define PCP_RC_SERVER_OVERLOADED	7
#define PCP_RC_ADDRESS_MISMATCH		8  /* XXX not defined in the spec */
#define PCP_RC_NETWORK_FAILURE		20
#define PCP_RC_NO_RESOURCES		21
#define PCP_RC_UNSUPP_PROTOCOL		22
#define PCP_RC_NOT_AUTHORIZED		23
#define PCP_RC_USER_EX_QUOTA		24
#define PCP_RC_CANT_PROVIDE_EXT_PORT	25
#define PCP_RC_EXCESSIVE_REMOTE_PEERS	26
#define PCP_RC_UNAUTH_THIRD_PARTY	51
#define PCP_PROTO_ALL			0
#define PCP_OPT_UNPROCESSED		0
#define PCP_OPT_FILTER			2
#define PCP_OPT_PREFER_FAILURE		3
#define PCP_OPT_THIRD_PARTY		4
